/* Copyright (c) 1999-2000 by Juliusz Chroboczek.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE. */

#ifndef _UGridP_h
#define _UGridP_h

#include "UGrid.h"
#include <X11/Xaw/SimpleP.h>

typedef struct {int dummy;} UGridClassPart;

typedef struct _UGridClassRec {
    CoreClassPart core_class;
    SimpleClassPart simple_class;
    UGridClassPart ugrid_class;
} UGridClassRec;

extern UGridClassRec ugridClassRec;

typedef struct {
    XFontStruct *font;
    int cell_cols, cell_rows;
    int cell_width, cell_height;
    Pixel foreground_pixel;
    Pixel grid_pixel;
    int internal_pad;
    Dimension start_codepoint;
    int grid_width;
    XtCallbackList callbacks;

    /* private state */
    Dimension selected_codepoint;
    GC text_gc;
    GC grid_gc;
    GC selected_gc;
} UGridPart;

typedef struct _UGridRec {
    CorePart core;
    SimplePart simple;
    UGridPart ugrid;
} UGridRec;

#endif

